<template>
  <q-page class="flex flex-top q-pa-xl">
    <q-form
      v-on:submit="onSubmit"
      v-on:reset="onReset"
      class="q-gutter-md"
    >
      <q-input
        filled
        v-model="fullName"
        label="Nombre Completo *"
        hint="Nombre y Apellido"
        lazy-rules
        v-bind:rules="[ val => val && val.length > 0 || 'Ingrese su nombre, por favor.']"
      />

      <q-input
        filled
        type="email"
        v-model="email"
        label="Correo Electrónico *"
        hint="Su email de conctacto"
        lazy-rules
        v-bind:rules="[ val => val && val.length > 0 || 'Ingrese su correo, por favor.']"
      />

      <q-input
        filled
        type="email"
        v-model="confirmEmail"
        label="Confirme su correo Electrónico *"
        hint="Debe coincidir con su email de conctacto"
        lazy-rules
        v-bind:rules="[ val => val && val.length > 0 || 'Ingrese su correo, por favor.']"
      />

      <q-input
        v-model="password"
        label="Contraseña *"
        filled
        v-bind:type="isPwd ? 'password' : 'text'"
        hint="Mínimo 6 caracteres"
        lazy-rules
        v-bind:rules="[ val => val && val.length > 6 || 'Ingrese una contraseña segura, por favor.']"
      >
        <template v-slot:append>
          <q-icon
            v-bind:name="isPwd ? 'visibility_off' : 'visibility'"
            class="cursor-pointer"
            v-on:click="isPwd = !isPwd"
          />
        </template>
      </q-input>

      <q-input
        v-model="confirmPassword"
        label="Confirme Contraseña *"
        filled
        v-bind:type="isPwd ? 'password' : 'text'"
        hint="Debe coincidir con su contraseña"
        lazy-rules
        v-bind:rules="[ val => val === password || 'No coincide con su contraseña']"
      >
        <template v-slot:append>
          <q-icon
            v-bind:name="isPwd ? 'visibility_off' : 'visibility'"
            class="cursor-pointer"
            v-on:click="isPwd = !isPwd"
          />
        </template>
      </q-input>

      <div>
        <q-btn label="Guardar cambios" type="submit" color="primary"/>
        <q-btn label="Cancelar" type="reset" color="primary" flat class="q-ml-sm" />
      </div>

    </q-form>
  </q-page>
</template>
<script>
import { mapGetters } from 'vuex'
export default {
  name: 'ConfigPerfil',
  data () {
    return {
      fullName: null,
      email: null,
      password: null,
      isPwd: true,
      confirmPassword: null,
      confirmEmail: null
    }
  },
  computed: {
    ...mapGetters({
      userName: 'auth/getName',
      userId: 'auth/getId'
    })
  },
  mounted () {
    this.fullName = this.userName
    this.$connection.get('api/users/' + this.userId)
      .then((response) => {
        this.email = response.data.email
        this.confirmEmail = response.data.email
      })
      .catch(() => {
        this.$q.notify({
          color: 'negative',
          textColor: 'white',
          icon: 'cloud_off',
          message: 'Error al recuperar su información.'
        })
        this.$store.dispatch('auth/logOut')
        this.$router.go('/home')
      })
  },
  methods: {
    onSubmit () {
      if (this.password === null || this.password.length === 0) {
        this.$q.notify({ color: 'negative', textColor: 'white', icon: 'fas fa-check-circle', message: 'Contraseña no aceptada' })
      } else {
        this.$connection.post('update/users', {
          id: this.userId,
          fullName: this.fullName,
          email: this.email,
          password: this.password,
          confirmPassword: this.confirmPassword,
          confirmEmail: this.confirmEmail,
          term: true
        })
          .then(() => {
            this.$q.notify({
              color: 'positive',
              textColor: 'white',
              icon: 'cloud_done',
              message: 'Modificaciones exitosas en el sistema. Por favor, vuelva a iniciar sesión'
            })
            this.$store.dispatch('auth/logOut')
            this.$router.go(-1)
          })
          .catch(() => {
            this.$q.notify({
              color: 'negative',
              textColor: 'white',
              icon: 'cloud_off',
              message: 'Error al modificar su cuenta. Por favor, vuelvalo a intentar más tarde.'
            })
          })
          .finally(() => {
            this.password = null
            this.confirmPassword = null
          })
      }
    },
    onReset () {
      this.$router.go(-1)
    }
  }
}
</script>
